"""

 Linbot Configuration file
 Edit this file to your choosing.  This is just a regular Python module, so
 if you want to do something fancy with it, go right ahead. Just make sure
 that all variables are defined and have an appropriate value .

"""


BODY_BGCOLOR = 'white'
BODY_TEXT = 'black'
BODY_LINK = 'blue'
BODY_VLINK = '#CD0000'
BODY_ALINK = 'magenta'

# titles for the pages (and navigation bar)
SITE_MAP_TITLE     = 'Site Map'
BAD_LINKS_TITLE    = 'Broken Links'
IMAGE_TITLE        = 'Images'
OLD_URL_TITLE      = "What's Old"
NEW_URL_TITLE      = "What's New"
EXTERNAL_TITLE     = 'External Links'
CONFIG_TITLE       = 'Configuration Options'

# filenames for the above pages
MAIN_FILENAME      = 'index.html'
NAVBAR_FILENAME    = 'navbar.html'
SITE_MAP_FILENAME  = 'map.html'
BAD_LINKS_FILENAME = 'broken.html'
IMAGE_FILENAME     = 'images.html'
OLD_URL_FILENAME   = 'old.html'
NEW_URL_FILENAME   = 'new.html'
EXTERNAL_FILENAME  = 'extern.html'
CONFIG_FILENAME    = 'config.html'

TITLE_BGCOLOR = '#CFCFCF'
TITLE_COLOR = 'black'

NAVBAR_BGCOLOR = 'white'
NAVBAR_TEXT = 'white'
NAVBAR_LINK = 'white'
NAVBAR_VLINK = 'white'
NAVBAR_ALINK = '#FF0000'

# background color of title in navigation frame
NAVBAR_HEADER_COLOR = '#CD0000'

# backround color of options in navigation frame
NAVBAR_OPTION_COLOR = 'black'


# url to logo (image) shown on all pages
LOGO_HREF="http://home1.gte.net/marduk/linbot/linbot.gif"

# this is currently unused (but don't delete it)
MAX_RECURSION = 5

# number of columns in thumbnail image page
IMAGE_COLS=5

# width of thumbnail images
IMAGE_WIDTH=100

# height of thumbnail images
IMAGE_HEIGHT=100

IMAGE_BGCOLOR = '#EEEEE0'

# background color of header in 'What's Old' and 'What's New' pages
AGE_HEADER_COLOR = '#CCCC99'

# background color of links
AGE_LINK_COLOR = '#EEEEE0'

# background color of age field
AGE_DAYS_COLOR = '#DDDDD0'

# maximum age (in days) for a url to be considered new
NEW_URL_AGE = 7

# minimum age (in days) for a url to be considered old
OLD_URL_AGE = 30

# colors for 'Bad Links' page
BAD_LINKS_LINK_COLOR = '#CCCC99'
BAD_LINKS_STATUS_COLOR = '#BBBBB0' 
BAD_LINKS_PARENT_HEADER_COLOR = 'EEEEE0'
BAD_LINKS_PARENT_COLOR = '#DDDDD0'

# if this is true, linbot will consider external all links that do not start in 
# the same directory level as the base url.  For example, given
# linbot http://www.myhost.com/~me/
# 'http://www.myhost.com/~me/stuff/index.html' would be considered internal while
# 'http://www.myhost.com/index.html' would be considered external.
# The default is false (0). note this can be overriden with the -b command-line
# flag
BASE_URLS_ONLY=0

# this is a (Python) list of URLs that should not be explored.  This can also
# be passed to linbot via the -x command line switch
#EXCLUDED_URLS = ['http://home1.gte.net/marduk/linbot/']
EXCLUDED_URLS = []

# Normally linbot will check links to "external" sites at the top level to
# ensure that your pages don't refer to broken links that are not at your
# site. However, you may not want this.  Setting this option to 1 will cause
# linbot to not check external links.  Note a link that is part of the. This
# can also be set with the command-line -a switch
#
# EXCLUDED_URLS list is considered external
AVOID_EXTERNAL_LINKS = 0


# hostnames (for example, www.myhost.com) which are to be considered local to
# your site.  Note that by default, the base URL of your site is considered
# local.  This can also be passed via command-line (see documentation for details
#
# HOSTS = ['home1.gte.net','manson.ddns.org']
HOSTS = [] 

# Directory where files generated by linbot will be placed.  This can also be
# specified via the -o command-line flag.
OUTPUT_DIR = '.'

SHOW_CONFIG_PAGE = 1


################## you shouldn't need to change anything below #################

__version__='0.2'
__author__='marduk (marduk@gte.net)'  
LINBOT_HOME='http://home1.gte.net/marduk/linbot/index.html'
