#!/usr/bin/python


__version__='0.2'
__author__ = 'marduk (marduk@gte.net)'

USAGE='linbot [-x url]... [-b][-a][-o dir] url [location]...'
level = 0
explored = []

import sys
import time

start_time = time.ctime(time.time())
try:
    import config
except ImportError:
    sys.stdout.write('Please place a copy of "config.py" in this directory\n')
    sys.exit(1)

import myUrlLib
Link=myUrlLib.Link
myUrlLib.config=config

CODES=myUrlLib.HTTP_STATUS_CODES

def parse_args():
    import getopt
    global URL
    try:
	optlist, args = getopt.getopt(sys.argv[1:],'x:ao:b')
    except getopt.error, reason:
	print reason
	print USAGE
	sys.exit(1)
    for flag,arg in optlist:
	if flag=='-x':
	    config.EXCLUDED_URLS.append(myUrlLib.urlformat(arg))
	elif flag=='-a':
	    config.AVOID_EXTERNAL_LINKS=1
	elif flag=='-o':
	    config.OUTPUT_DIR=arg
	elif flag=='-b':
	    config.BASE_URLS_ONLY=1

    if len(args)==0:
	print USAGE
	sys.exit(1)
    else: URL = args[0]
    config.HOSTS=args[1:]

def sort_by_age(a,b):
    """ sort helper for url's age.  a and b are urls in Link.linkList """
    aage, bage = Link.linkList[a].age, Link.linkList[b].age
    if aage < bage:
	return -1
    if aage == bage:
	return 0
    return 1

def sort_by_rev_age(a,b):
    aage, bage = Link.linkList[a].age, Link.linkList[b].age
    if aage > bage:
	return -1
    if aage == bage:
	return 0
    return 1

def open_file(filename):
    """ given filename (and config.OUTPUT_DIR) opens filename for writing and
    returns the file object """
    return open(config.OUTPUT_DIR + filename,'w')
    
def get_title(url):
    """ returns the title of a url if it is not None, else returns url
    note that this implies Link.linkList[url] """
    link=Link.linkList[url]
    if link.title is None:
	return url
    return link.title

class Page:
    # this is a class which describes an HTML pointed to in the navbar
     def __init__(self,title,filename,function):
	self.title = title
	self.filename = filename
	self.function = function

	
def doTopMain(title=''):
    """top part of html files in main frame prints to stdout"""
    print '<html>'
    print '<head><title>%s</title></head>' % title
    print '<body \
             text="%(BODY_TEXT)s" \
	     bgcolor="%(BODY_BGCOLOR)s" \
	     link="%(BODY_LINK)s" \
	     vlink="%(BODY_VLINK)s" \
	     alink="%(BODY_ALINK)s">' % vars(config)
    print '<p align=center>'
    print '<img src="%(LOGO_HREF)s">' % vars(config)
    print '<H1 align=center><a href="%s">%s</a></H1>' \
	  % (base.URL, get_title(base.URL))
    print '<TABLE width="100%%" bgcolor="%(TITLE_BGCOLOR)s">' \
	  % vars(config)
    print '<TR><TD align=left valign=center>',
    print '<FONT SIZE="+2" COLOR="%s"><strong>&nbsp;%s</strong></FONT>' \
	  % (config.TITLE_COLOR,title)
    print '</TD></TR>\n</TABLE>'
    print


def doBotMain():
    """ bottom part of html files in main frame"""
    print 
    print '<hr>'
    print '<p><em>Generated %s by <a target="_top" href="%s">Linbot %s</a></em>' \
	  % (start_time,config.LINBOT_HOME, __version__)
    print '</body>'
    print '</html>'


def main_index():
    fp = open_file(config.MAIN_FILENAME)
    sys.stdout=fp
    
    print '<html>'
    print '<head>'
    print '<title>Linbot report for "%s"</title>' % get_title(base.URL)
    print '</head>'
    print '<frameset COLS="20%,80%" border=0 frameborder=0 framespacing=0>'
    print '<frame name="navbar" src="%s" marginwidth=0 marginheight=0>' \
	  % config.NAVBAR_FILENAME
    print '<frame name="main" src="%s">' % config.SITE_MAP_FILENAME
    print '</frameset>'
    print '</html>'
    fp.close()


def nav_bar(pages):
    # navigation bar
    fp=open_file(config.NAVBAR_FILENAME)
    sys.stdout=fp
    print '<html>\n<head>'
    print '\t<title>navbar</title>'
    print '\t<base target="main">'
    print '</head>'
    print '<body bgcolor="%(NAVBAR_BGCOLOR)s" \
               text="%(NAVBAR_TEXT)s" \
	       link="%(NAVBAR_LINK)s" \
	       vlink="%(NAVBAR_VLINK)s" \
	       alink="%(NAVBAR_ALINK)s">' % vars(config)
    print '<div align=center>'
    print '<table width="100%" cellpadding=7 cellspacing=2>'
    # title
    print '<tr><th bgcolor="%s" align=center valign=middle>Linbot %s</th></tr>' \
	  % (config.NAVBAR_HEADER_COLOR, __version__)

    # 'buttons' pointing to each individual page
    for page in pages:
	print '<tr>'
	print '<th bgcolor="%s" align=center valign=middle>' \
	      %  config.NAVBAR_OPTION_COLOR,
	print '<strong><a href="%s">%s</a></td></tr></strong>' \
	      % (page.filename, page.title)

	# create the file we just pointed to
	tmp = sys.stdout
	fp = open_file(page.filename)
	sys.stdout = fp
	doTopMain(page.title)
	apply(page.function)
	doBotMain()
	fp.close()
	sys.stdout = tmp
	
    # linbot home
    print '<tr><td bgcolor="%s" align=center>' % config.NAVBAR_OPTION_COLOR,
    print '<strong><a target="_top" href="%s">' \
	  % config.LINBOT_HOME,
    print 'Linbot Home Page</a></strong></td></tr>'
    print
    print '</table>'
    print '</div>'
    print '</body>'
    print '</html>'

    fp.close()

def explore(link):
    """given a Link object, print out it's children in HTMl format"""
    global level
    if link in explored: return
    explored.append(link)
    print "<UL>"
    for i in link.children:
	child = Link.linkList[i]
	#	if child not in explored:
	if i in Link.badLinks:
	    print '<LI>%s' % i
	else:
	    print '<LI><a href="%s">%s</a>' % (i, get_title(i))
	    explore(child)
    print "</UL>"
    return

def site_map():	
    # site map
    explore(base)

def bad_links():
    #bad links
    print '<TABLE align=center width="75%" border=0 cellspacing=2>'
    for link in Link.badLinks:
	#print `Link.linkList[link].parents`
	print '<TR><TD colspan=2>&nbsp;</TD></TR>'
	print '<TR bgcolor="%s"><TH align=right>Link</TH><TD align=left>%s</TD></TR>' \
	      % (config.BAD_LINKS_LINK_COLOR, link),
	status = str(Link.linkList[link].status)
	if status in CODES.keys():
	    status = status + ": " + CODES[status]
	print '<TR bgcolor="%s"><TH align=right>Status</TH><TD align=left>%s</TD></TR>' \
	      % (config.BAD_LINKS_STATUS_COLOR,status)
	print '<TR><TH bgcolor="%s" align=right valign=top rowspan="%s">Parents</TH>' \
	      % (config.BAD_LINKS_PARENT_HEADER_COLOR, len(Link.linkList[link].parents))
	for parent in Link.linkList[link].parents:
	    #if parent!=Link.linkList[link].parents[0]: print '<TR>'
	    print '<TD bgcolor="%s"><a href="%s">%s</a></TD><TR>' \
		  % (config.BAD_LINKS_PARENT_COLOR,parent,get_title(parent))
	
    print '</TABLE>'


def images():    
    # images
    import math
    imagelist=Link.images

    currentPic=0
    rows = int(math.ceil(len(imagelist)/config.IMAGE_COLS))+1
    print '<TABLE border=0>'
    
    for row in range(rows):
	print'<TR>'
	for col in range(config.IMAGE_COLS):
	    if currentPic==len(imagelist): break
	    image=imagelist[currentPic]
	    print '\t<td bgcolor="%s"><a href="%s">' \
		  % (config.IMAGE_BGCOLOR,image)
	    print '<img src="%s" width="%d" height="%d"></A></TD>' \
		  % (image,config.IMAGE_WIDTH,config.IMAGE_HEIGHT)
	    currentPic = currentPic + 1

	print '</tr>'
    print '</table>\n\n</body>\n</html>'

def whats_new():
    # what's new
    print '<TABLE align=center border=0 cellpadding=2 cellspacing=2 width="75%">'
    print '<TR bgcolor="%s"><TH align=center>Link</TH>' % config.AGE_HEADER_COLOR,
    print '<TH align=center>Age (Days)</TH></TR>'
    urls = Link.linkList.keys()
    urls.sort(sort_by_age)
    for url in urls:
	link=Link.linkList[url]
	age = link.age
	if (age is not None)and (age <= config.NEW_URL_AGE):
	    print '<TR><TD bgcolor="%s"><a href="%s">%s</a></TD>' \
		  % (config.AGE_LINK_COLOR, url, get_title(url)),
	    print '<TD align=center bgcolor="%s">%s</TD></TR>' % \
		  (config.AGE_DAYS_COLOR, str(age))
    print '</TABLE>'

def whats_old():
    # what's old
    print '<TABLE align=center border=0 cellpadding=2 cellspacing=2 width="75%">'
    print '<TR bgcolor="%s"><TH align=center>Link</TH>' % config.AGE_HEADER_COLOR,
    print '<TH align=center>Age (Days)</TH></TR>'
    urls = Link.linkList.keys()
    urls.sort(sort_by_rev_age)
    for url in urls:
	link=Link.linkList[url]
	age = link.age
	if age and (age >= config.OLD_URL_AGE):
	    print '<TR><TD bgcolor="%s"><a href="%s">%s</a></TD>' \
		  % (config.AGE_LINK_COLOR, url, get_title(url)),
	    print '<TD align=center bgcolor="%s">%s</TD></TR>' \
		  % (config.AGE_DAYS_COLOR, str(age))
    print '</TABLE>'

def external():
    # external links
    print '<OL>'
    for url in Link.linkList.keys():
	link=Link.linkList[url]
	external = link.external
	if external:
	    print '\t<LI><a href="%s">%s</a>' % (url, get_title(url))
    print '</OL>'

def config_page():
    # configuration options
    import string
    print '<TABLE width="75%" align=center border=0 cellpadding=2 cellspacing=2>'
    print '<TR align=center valign=middle">'
    print '<TH>Name</TH><TH>Value</TH>'
    variables = vars(config)
    sorted=variables.keys()
    sorted.sort()
    for variable in sorted:
	if variable[:2]=="__": continue # don't show special variables
	print '<TR>'
	print '<TD bgcolor="%s" align=left valign=middle>' \
	      %  (config.TITLE_BGCOLOR),
	print '%s</TD>' % variable,
	print '<TD bgcolor="%s" align=left valign=middle>' \
	      %  (config.TITLE_BGCOLOR),
	print '%s</TD>' % str(variables[variable]),
	print '</TR>'
    print '<TD bgcolor="%s" align=left valign=middle>' \
	  %  (config.TITLE_BGCOLOR),
    print 'Command</TD>',
    print '<TD bgcolor="%s" align=left valign=middle>' \
	  %  (config.TITLE_BGCOLOR),
    print '%s' % string.join(sys.argv)
    print '</TABLE>'


if __name__=='__main__':

    parse_args()
    
    config.OUTPUT_DIR=config.OUTPUT_DIR + '/'

    
    print 'checking site....'
    base=myUrlLib.Link(URL,None) # this will take a while
    print 'done.'

    # now we can write out the files
    # start with the frame-description page
    main_index()
    
    # set up the pages
    pages = []
    pages.append(Page(config.SITE_MAP_TITLE,config.SITE_MAP_FILENAME,site_map))
    pages.append(Page(config.BAD_LINKS_TITLE,config.BAD_LINKS_FILENAME,bad_links))
    pages.append(Page(config.IMAGE_TITLE,config.IMAGE_FILENAME,images))
    pages.append(Page(config.OLD_URL_TITLE,config.OLD_URL_FILENAME,whats_old))
    pages.append(Page(config.NEW_URL_TITLE,config.NEW_URL_FILENAME,whats_new))
    pages.append(Page(config.EXTERNAL_TITLE,config.EXTERNAL_FILENAME,external))
    if config.SHOW_CONFIG_PAGE:
	pages.append(Page(config.CONFIG_TITLE,config.CONFIG_FILENAME,config_page))
    
    # create the navigation bar, which creates the pages it points to
    nav_bar(pages)









 

    
