#!/usr/bin/python


__version__ = '0.2'
__author__ = 'marduk (marduk@gte.net)'

HTTP_STATUS_CODES= {'100':"Continue",
		    '101':"Switching Protocols",
		    '200':"OK",
		    '201':"Created",
		    '202':"Accepted",
		    '204':"No Content",
		    '205':"Reset Content",
		    '206':"Partial Content",
		    '300':"Multiple Choices",
		    '301':"Moved Permanently",
		    '302':"Moved Temporarily",
		    '303':"See Other",
		    '304':"Not Modified",
		    '305':"Use Proxy",
		    '400':"Bad Request",
		    '401':"Unauthorized",
		    '402':"Payment Required",
		    '403':"Forbidden",
		    '404':"Not Found",
		    '405':"Method Not Allowed",
		    '406':"Not Acceptable",
		    '407':"Proxy Authentication Required",
		    '408':"Request Time-out",
		    '409':"Conflict",
		    '410':"Gone",
		    '411':"Length Required",
		    '412':"Precondition Failed",
		    '413':"Request Entity Too Large",
		    '414':"Request-URI Too Large",
		    '415':"Unsupported Media Type",
		    '500':"Internal Server Error",
		    '501':"Not Implemented",
		    '502':"Bad Gateway",
		    '503':"Service Unavailable",
		    '504':"Gateway Time-out",
		    '505':"HTTP Version not supported"
		    }

config = None
robot_parsers={}
SECS_PER_DAY=60*60*24

from urllib import *
import htmllib
import httplib
import robotparser

class MyFancyURLopener(FancyURLopener):
    """ i need to override open and open_http to return the error status as 
    well as the file and headers """

    errcode = None

    def __init__(self, proxies=None):
	FancyURLopener.__init__(self, proxies)
	
    def __del__(self):
	FancyURLopener.close(self)

    def open(self,fullurl, data=None):
	self.errcode = None
	return FancyURLopener.open(self,fullurl, data)

    # Use HTTP protocol
    def open_http(self, url, data=None):
	if type(url) is type(""):
	    host, selector = splithost(url)
	    user_passwd, host = splituser(host)
	    realhost = host
	else:
	    host, selector = url
	    urltype, rest = splittype(selector)
	    user_passwd = None
	    if string.lower(urltype) != 'http':
		realhost = None
	    else:
		realhost, rest = splithost(rest)
		user_passwd, realhost = splituser(realhost)
		if user_passwd:
		    selector = "%s://%s%s" % (urltype,
					      realhost, rest)
	     #print "proxy via http:", host, selector
	if not host: raise IOError, ('http error', 'no host given')
	if user_passwd:
	    import base64
	    auth = string.strip(base64.encodestring(user_passwd))
	else:
	    auth = None
	h = httplib.HTTP(host)
	if data is not None:
	    h.putrequest('POST', selector)
	    h.putheader('Content-type',
			'application/x-www-form-urlencoded')
	    h.putheader('Content-length', '%d' % len(data))
	else:
	    h.putrequest('GET', selector)
	if auth: h.putheader('Authorization', 'Basic %s' % auth)
	if realhost: h.putheader('Host', realhost)
	for args in self.addheaders: apply(h.putheader, args)
	h.endheaders()
	if data is not None:
	    h.send(data + '\r\n')
	errcode, errmsg, headers = h.getreply()
	fp = h.getfile()
	self.errcode = errcode
	if errcode == 200:
	    return addinfourl(fp, headers, self.openedurl)
	else:
	    return self.http_error(url,
				   fp, errcode, errmsg, headers)
		    
############################################################################
class Link:
    """ my class of url's which includes parents, HTTP status number, and
        a list of URL's in that link urls should be passed urlformat()ed
    """

    linkList = {}
    badLinks = []
    images=[]
    baseurl = ""
    base=""

    def __init__(self,url,parent):
	self.init()

	print '\tparent = ' + str(parent)
	opener = MyFancyURLopener()
	from urlparse import *

	parsed = urlparse(url)
	self.scheme = parsed[0]
	location = parsed[1]

	#elf.URL=url
	#self.URL = urlformat(url,parent)
	#print '\tURL: '+ str(self.URL)
	#Link.linkList[self.URL]=self
	
	if parent not in self.parents:
	    if parent: self.parents.append(parent)
	    
	# we want to ignore url's that are not http, ftp, or file
	if self.scheme not in ['http','ftp','file']:
	    self.status="Not Checked"
	    self.external=1
	    self.URL=url
	    Link.linkList[self.URL]=self
	    print '\tNot checked'
	    return
	
	if (parent is None):
	    if (location and location not in config.HOSTS): 
		# this is the base host
		import string
		config.HOSTS.append(location)
	    for host in config.HOSTS:
		print '\tGetting robots.txt for %s' % host
		rp=robotparser.RobotFileParser()
		try:
		    rp.set_url(urlunparse((self.scheme,host,'/robots.txt','','','')))
		except:
		    continue
		rp.read()
		robot_parsers[host]=rp

	# see if robots.txt will let us in
	if robot_parsers.has_key(location):
	    if not robot_parsers[location].can_fetch('Linbot',url):
		print '\tRobot Restricted'
		self.status='Not Checked'
		#self.external=1
		return

	# open url
	try:
	    tmpFileName, self.headers = opener.retrieve(urlformat(url,parent))
	except IOError, data:
	    self.set_bad_link(url,str(data.errno) + ': ' + str(data.strerror))
	    return
	except:
	    self.set_bad_link(url,"Unkown error: Bad URL?")
	    return
	    
	htmlfile = open(tmpFileName,'r')

	self.URL=opener.openedurl
	Link.linkList[self.URL]=self

	if parent is None:
	    Link.baseurl=self.URL
	    Link.base=self.URL[:string.rfind(self.URL,'/')+1]
	    print '\tbase: %s' % Link.base

	# if could get httpfile:
	self.status = opener.errcode

	
	if (self.scheme=='http'):
	    if not hasattr(self.headers,'getheader'):
		print '\tDocument contains no data'
		self.URL=url
		Link.linkList[self.URL]=self
		Link.badLinks.append(self.URL)
		return
	    if (self.headers.getheader("Content-Type")=="text/html"):
		if self.status==200:
		    self._handleHTML(self.URL,htmlfile)
		else:
		    print '\tBad Link'
		    self.URL=url
		    Link.linkList[self.URL]=self
		    Link.badLinks.append(self.URL)
	elif self.scheme in ['file','ftp']:
	    # find out if this is an html file
	    if isHTML(self.URL):
		self._handleHTML(self.URL,htmlfile)
	else: 
	    return
	    
	if self.external:
	    return
	# add me to the linklist, if needed
	for child in self.children:
	    if not Link.linkList.has_key(child):
		print "adding url: %s" % child
		if is_external(child) or is_excluded(child):
		    Link.linkList[child]=ExternalLink(child,self.URL)
		else:
		    Link.linkList[child]=Link(child,self.URL)
	    elif self.URL not in Link.linkList[child].parents:
		Link.linkList[child].parents.append(self.URL)
	return # __init__

    def init(self):
	""" initialize some variables """
	self.age = None
	self.scheme = None
	self.headers = None
	self.parents=[]
	self.children=[]
	self.status = None
	self.title = None
	self.external=0

    def set_bad_link(self,url,status):
	""" flags the link as bad """
	print '\t' + str(status)
	self.status = str(status)
	self.URL=url
	Link.linkList[self.URL]=self
	Link.badLinks.append(self.URL)

    def _handleHTML(self,url,htmlfile):
	"""examines and html file and updates the Link object"""
	# get anchorlist
	(anchorlist, imagelist, title) = pageLinks(url,htmlfile)
	
	print '\ttitle: %s' % str(title)
	for child in anchorlist:
	    if child not in self.children:
		self.children.append(child)
	# get image list
	for image in imagelist:
	    if image not in Link.images:
		print 'adding image: %s' % image
		Link.images.append(image)
		    
	self.age = self.getAge()
	self.title=title
	return

    def getAge(self):
	# get age of link
	import time
	if self.scheme=='http':
	    try:
		lastMod = time.mktime(self.headers.getdate('Last-Modified'))
	    except (OverflowError, TypeError, ValueError):
		lastMod = None
	    if lastMod:
		age = int((time.time()-lastMod)/SECS_PER_DAY)
	    else:
		age = None
	    return age
	elif self.scheme=='file':
	    import stat
	    from urlparse import *
	    path = urlparse(self.URL)[2]
	    lastMod = os.stat(path)[stat.ST_MTIME]
	    age = int((time.time()-lastMod)/SECS_PER_DAY)
	    return age
	
class ExternalLink(Link):
    """ this class is just like Link, but it does not explore it's children """
    
    def __init__(self,url,parent):

	if config.AVOID_EXTERNAL_LINKS:
	    self.init()
	    self.status="Not Checked"
	    self.external=1
	    print '\tNot checked'
	    return
	Link.__init__(self,url,parent)
	self.external=1

    def _handleHTML(self,url,htmlfile):
	# ignore links and images, but use the title
	self.title = pageLinks(url,htmlfile)[2]
	print '\ttitle: %s' % str(self.title)
	self.children=[]
	self.age=self.getAge()

def is_external(url):
    """ returns true if url is an external link """
    from urlparse import *
    parsed = urlparse(url)
    scheme = parsed[0]
    location = parsed[1]
    if (location not in config.HOSTS) and (scheme in ['http','ftp']):
	return 1
    if config.BASE_URLS_ONLY and (Link.base!=url[:len(Link.base)]):
	return 1
    return 0

def is_excluded(url):
    """ returns true if url is part of the EXCLUDED_URLS list """
    for x in config.EXCLUDED_URLS:
	if x==url[:len(x)]:
	    return 1
    return 0


############################################################################    
# myHTMLParser class is derived from htmllib.HTMLParse but to handle images#
############################################################################
class MyHTMLParser(htmllib.HTMLParser):
		
    def __init__(self,formatter):
	self.imagelist = []
	htmllib.HTMLParser.__init__(self,formatter)
	
    # override handle_image() 
    def handle_image(self,src,alt,*stuff):
	if src not in self.imagelist: self.imagelist.append(src)

    def do_frame(self,attrs):
	for name, val in attrs:
	    if name=="src":
		self.anchorlist.append(val)

    def save_bgn(self):
	self.savedata = ''
	

    def save_end(self):
	data = self.savedata
	self.savedata = None
	return data

    def start_title(self, attrs):
	self.save_bgn()

    def end_title(self):
	if not self.savedata:
	    self.title = None
	    return
	self.title=self.save_end()



def pageLinks(url,page):
    """ returns a list of all the url's in a page.  page should be a file object
    Partial urls will be expanded using <url> parameter"""
    import htmllib
    from urlparse import *
    from formatter import NullFormatter

    parser = MyHTMLParser(NullFormatter())
    parser.feed(page.read())
    urllist = []
    imagelist = []
    title = None
	
    title = parser.title
    for anchor in parser.anchorlist:
	anchor=urlformat(anchor,url)
	if anchor not in urllist: urllist.append(anchor)
	
	for image in parser.imagelist:
	    image=urlformat(image,url)
	    if image not in imagelist: imagelist.append(image)
		
    return (urllist, imagelist, title)


def urlformat(url,parent=None):
    """ returns a formatted version of URL, which, adds trailing '/'s, if 
    necessary, deletes fragmentation identifiers '#' and expands partial url's 
    based on parent"""
    
    from urlparse import *
    
    method=urlparse(url)[0]
    if (method=='') and (parent != None):
	url=urljoin(parent,url)
    parsedlist = list(urlparse(url))
    parsedlist[5]='' # remove fragment
    # parsedlist[4]='' # remove query string
    url = urlunparse(tuple(parsedlist))
    return url
    

def isHTML(filename):
    """ returns true if filename reflects and html file.  Note this is not an
    exact science"""
    
    from string import *

    extensions = ['html','htm','shtml','shtm','stm'] # asp ?
    
    extension=filename[rfind(filename,'.')+1:len(filename)]
    return (extension in extensions)
    

def calAge(lastmod):
    """ returns the age in days since <lastmod> """

    
